<template>
    <v-card>
        <v-card-text>
            <v-form 
                @submit.prevent="submit" 
                v-model="valid"
                ref="form" 
                >
                <v-container>
                    <v-row>
                        <v-col>
                            <v-text-field 
                                v-model="form.title"
                                :rules="[
                                    v => !!v || 'Title is required',
                                    v => (v && v.length < 20) || 'Title must be less than 20 characters',
                                ]"
                            ></v-text-field>
                        </v-col>
                    </v-row>
                    <v-row>
                        <v-col>
                            <v-btn type="submit">Create</v-btn>
                            <v-btn @click="cancel">Cancel</v-btn>
                        </v-col>
                    </v-row>
                </v-container>
            </v-form>
        </v-card-text>
    </v-card>
</template>

<script>
    export default {
        name: "CreateNewTodo",
        props:{
            listId:{
                required: true,
                type: [String, Number],
            },
            onCreate:{
                required: true,
            },
            onCancel:{
                required: true,
            }
        },
        data: ()=>({
            valid: true,
            form: {
                title: '',
                description: '', // can be added via dialog later on
                date: Date.now(),
            }
        }),
        methods:{
            submit(){
                this.$refs.form.validate()
                if(!this.valid) return;

                const newTodo = {
                    ...this.form,
                    list: this.listId,
                }
                this.onCreate(newTodo);
                this.reset();
            },
            reset(){
                this.form = {
                    title: '',
                    description: '',
                    date: Date.now(),
                }
                this.$refs.form.resetValidation()
            },
            cancel(){
                this.onCancel();
                this.reset();
            }
        }
    }
</script>

<style lang="scss" scoped>

</style>